/**
 *#########################################################################
 *
 * A component of the Gatherer application, part of the Greenstone digital
 * library suite from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * <BR><BR>
 *
 * Author: John Thompson, Greenstone Digital Library, University of Waikato
 *
 * <BR><BR>
 *
 * Copyright (C) 1999 New Zealand Digital Library Project
 *
 * <BR><BR>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * <BR><BR>
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * <BR><BR>
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *########################################################################
 */
package org.greenstone.gatherer.msm;

import org.greenstone.gatherer.file.FileNode;

/** Provides an interface for all parsers which should be called during the 'search for existing metadata' phase of a file copy. 
 * @author John Thompson, Greenstone Digital Library, University of Waikato
 * @version 2.3
 */
public interface MetadataParser {
    /** Locate and import any metadata parsed by this metadata parser given the file involved and its previous incarnation. The last parameter indicates that the parser is forced to assign otherwise folder level metadata to the desired -files-. If the filenode was a directory folder_level is automatically true.*/
    public boolean process(FileNode destination, FileNode origin, boolean folder_level, boolean dummy_run);
}
